<?PHP 

    require_once("../../config.php");
    require_once("lib.php");
    
    require_variable($id);   // course

    if (! $course = get_record("course", "id", $id)) {
        error("Course ID is incorrect");
    }

    require_login($course->id);

  //  add_to_log($course->id, "gallery", "view all", "index.php?id=$course->id", "");


/// Get all required strings

    $strgalleries = get_string("modulenameplural", "gallery");
    $strgallery  = get_string("modulename", "gallery");


/// Print the header

    if ($course->category) {
        $navigation = "<A HREF=\"../../course/view.php?id=$course->id\">$course->shortname</A> ->";
    }

    print_header("$course->shortname: $strgalleriess", "$course->fullname", "$navigation $strgalleries", "", "", true, "", navmenu($course));

/// Get all the appropriate data

    if (! $galleries = get_all_instances_in_course("gallery", $course)) {
        notice("There are no galleries", "../../course/view.php?id=$course->id");
        die;
    }

/// Print the list of instances (your module will probably extend this)

    $timenow = time();
    $strname  = get_string("name");
    $strweek  = get_string("week");
    $strtopic  = get_string("topic");
    
    if ($course->format == "weeks") {
        $table->head  = array ($strweek,"",$strname);
        $table->align = array ("CENTER", "CENTER","LEFT");
    } else if ($course->format == "topics") {
        $table->head  = array ($strtopic, "", $strname);
        $table->align = array ("CENTER", "CENTER","LEFT");
    } else {
        $table->head  = array ($strname,"");
        $table->align = array ("CENTER","LEFT");
    }

    foreach ($galleries as $gallery) {
        if (!$gallery->visible) {
            //Show dimmed if the mod is hidden
            $link = "<A class=\"dimmed\" HREF=\"view.php?id=$gallery->coursemodule\">$gallery->name</A>";
            $img = "";
        } else {
            //Show normal if the mod is visible
            $link = "<A HREF=\"view.php?id=$gallery->coursemodule\">$gallery->name</A>";
            if (file_exists($CFG->dataroot.'/'.$gallery->course.'/'.$gallery->directory.'/'.$gallery->lastthumb)) {
                $img = gallery_display_image($gallery->course.'/'.$gallery->directory.'/'.$gallery->lastthumb,$gallery->name);				
            }
        }
        
        if ($course->format == "weeks" or $course->format == "topics") {
            $table->data[] = array ($gallery->section, $img, $link);
        } else {
            $table->data[] = array ($img, $link);
        }
    }

    echo "<BR>";

    print_table($table);

/// Finish the page

    print_footer($course);

?>