<?PHP  

/// Library of functions and constants for module gallery
define("GALLERY_NOCOMMENTS",      "0");
define("GALLERY_MODERATEDCOMMENTS",      "1");
define("GALLERY_COMMENTS",      "2");

$GALLERY_MODERATION = array (GALLERY_NOCOMMENTS       => get_string("nocomments",      "gallery"),
                          GALLERY_MODERATEDCOMMENTS  => get_string("moderatedcomments", "gallery"),
                          GALLERY_COMMENTS => get_string("canpostcomments", "gallery")
                          );

define("GALLERY_MARGINR",      "0");
define("GALLERY_MARGINL",      "1");
define("GALLERY_FORUMMARGINR",      "2");
define("GALLERY_FORUMMARGINL",      "3");

$GALLERY_FORMAT = array (GALLERY_MARGINR       => get_string("marginr",      "gallery"),
                          GALLERY_MARGINL  => get_string("marginl", "gallery")
                          ); 
                          /* following formats might be added later ...
                          GALLERY_FORUMMARGINR => get_string("forummarginr", "gallery"),
                          GALLERY_FORUMMARGINL => get_string("forummarginl", "gallery")
                          );
                          */
                          
$thumb        = "thumb";            // Sub-directory where thumbnails are stored 

                          
$sortfile     = "sortfile";         // If it exists, contains filenames in order
$sortreverse  =  false;             // If true, then the sort order is reversed

$recentcount  =  10;                // How many 'recent' comments to show
$imagemethod   = check_gd_version();
if (!$imagemethod) {
    $imagemethod = "manual";
} else {
    $imagemethod = "gd".$imagemethod;
}    
             // gd1, gd2, imagemagick, manual, none  
                                    // gd1 - gd 1.* compiled into PHP
                                    // gd2 - gd 2.* compiled into PHP 4.0.6 or later
                                    // imagemagick - use imagemagick "convert" and "identify"
                                    // manual - create your own thumbnails elsewhere
                                    // none - don't use thumbnail images

$captionmethod = "capfile";        // rdjpgcom, imagemagick, capfile, filename, none
                                    // rdjpgcom - use rdjpgcom program, part of libjpeg
                                    // imagemagick - use imagemagick program "identify"
                                    // capfile - use thumb/filename.jpg.cap files
                                    // filename - just use the filename as the caption
                                    // none - don't use any captions on images

// Depending on what you chose for $imagemethod and $captionmethod, set these:
$convert  = "/usr/bin/convert";     // Path to Imagemagick "convert" program
$identify = "/usr/bin/identify";    // Path to Imagemagick "identify" program
$rdjpgcom = "/usr/bin/rdjpgcom";    // Path to rdjpgcom program, if needed.
$wrjpgcom = "/usr/bin/wrjpgcom";    // If you are using rdjpgcom, set this too 
                                    // so admin can update (write) image captions
                          
                          
function gallery_add_instance($gallery) {
/// Given an object containing all the necessary data, 
/// (defined by the form in mod.html) this function 
/// will create a new instance and return the id number 
/// of the new instance.

    $gallery->timemodified = time();
  
    return insert_record("gallery", $gallery);
}


function gallery_update_instance($gallery) {
/// Given an object containing all the necessary data, 
/// (defined by the form in mod.html) this function 
/// will update an existing instance with new data.
    //
    
    global $CFG;
    $gallery->timemodified = time();
    $gallery->id = $gallery->instance;
    
    if ($gallery->prevresizeimage != $gallery->resizeimage) {         
        // delete previously resized images
        if (!gallery_delete_directory($CFG->dataroot.'/'.$gallery->course.'/'.$gallery->directory.'/'.$thumb,$resizeimage)) {
            error ("Could not delete resized images from $gallery->directory");
        }
    }

    if ($gallery->prevthumbsize != $gallery->thumbsize || $gallery->previmagequality != $gallery->imagequality) { 
        //delete previously created thumbnails
        if (!gallery_delete_directory($CFG->dataroot.'/'.$gallery->course.'/'.$gallery->directory.'/'.$thumb,"")) {
            error ("Could not delete resized images from $gallery->directory");
        }
    }
    
    return update_record("gallery", $gallery);
}


function gallery_delete_instance($id) {
/// Given an ID of an instance of this module, 
/// this function will permanently delete the instance 
/// and any data that depends on it.  

    if (! $gallery = get_record("gallery", "id", "$id")) {
        return false;
    }

    $result = true;

    # Delete any dependent records here #

    if (! delete_records("gallery", "id", "$gallery->id")) {
        $result = false;
    }

    return $result;
}

function gallery_user_outline($course, $user, $mod, $gallery) {
/// Return a small object with summary information about what a 
/// user has done with a given particular instance of this module
/// Used for user activity reports.
/// $return->time = the time they did it
/// $return->info = a short text description

    return $return;
}

function gallery_user_complete($course, $user, $mod, $gallery) {
/// Print a detailed representation of what a  user has done with 
/// a given particular instance of this module, for user activity reports.

    return true;
}

function gallery_print_recent_activity($course, $isteacher, $timestart) {
/// Given a course and a time, this module should find recent activity 
/// that has occurred in gallery activities and print it out. 
/// Return true if there was output, or false is there was none.

    global $CFG;

    return false;  //  True if anything was printed, otherwise false 
}

function gallery_cron () {
/// Function to be run periodically according to the moodle cron
/// This function searches for things that need to be done, such 
/// as sending out mail, toggling flags etc ... 

    global $CFG;

    return true;
}

function gallery_grades($galleryid) {
/// Must return an array of grades for a given instance of this module, 
/// indexed by user.  It also returns a maximum allowed grade.
///
///    $return->grades = array of grades;
///    $return->maxgrade = maximum allowed grade;
///
///    return $return;

   return NULL;
}

function gallery_get_participants($galleryid) {
//Must return an array of user records (all data) who are participants
//for a given instance of gallery. Must include every user involved
//in the instance, independient of his role (student, teacher, admin...)
//See other modules as example.

    return false;
}

function gallery_scale_used ($galleryid,$scaleid) {
//This function returns if a scale is being used by one gallery
//it it has support for grading and scales. Commented code should be
//modified if necessary. See forum, glossary or journal modules
//as reference.
   
    $return = false;

    //$rec = get_record("gallery","id","$galleryid","scale","-$scaleid");
    //
    //if (!empty($rec)  && !empty($scaleid)) {
    //    $return = true;
    //}
   
    return $return;
}

//////////////////////////////////////////////////////////////////////////////////////
/// Any other gallery functions go here.  Each of them must have a name that 
/// starts with gallery_ but I haven't yet renamed them all ...

function gallery_delete_directory($dir,$select) {
    //deletes all the images in a complete directory
    // $select = "", then this function is used for deleting all the thumbnails
    // $select is number, then this function is used for deleting all the resized images
    
    $imagelist = GetFileList($dir);
    foreach ($imagelist as $image) {
        if (file_exists("$dir/$select$image")) {
               if (! unlink("$dir/$select$image")) {
                   PrintError("An error occurred while deleting $select$image");
               } 
        }
    }
    return true;
}    


function gallery_isowner() {
	global $course;
	return isediting($course);
	//return isteacheredit($USER->id); //for the time being
}
function gallery_candisapprove(){
global $course;
return true;
}
function gallery_display_image($file, $alt="",$extra="") {
// returns an IMG tag to display the picture on the screen, $extra can contain extra parameters to be enclosed in the tag
		global $CFG;
	
		if ($CFG->slasharguments) {
							$ffurl = "file.php/$file";
						} else {
							$ffurl = "file.php?file=/$file";
						}
		return "<img $extra  src=\"$CFG->wwwroot/$ffurl\" BORDER=0 ALT=\"$alt\">";				
}


function RemoveNewLines (&$item, $key) {
   $item = chop($item);
}

function GetFileList( $dirname="." ) {   // Finds all the images
   // First check to see if there's a file called $sortfile
   // that contains a sorted list of filenames, one per line
   // otherwise, will default to all files in alphabetical order
   global $sortfile, $sortreverse;
   $files = array(); 

   if (file_exists("$dirname/$sortfile")) {
      $files = file($sortfile);
      array_walk($files, 'RemoveNewLines');
   } else {
      $dir = opendir( $dirname );
      while( $file = readdir( $dir ) ) {
         if (eregi("\.jpe?g$", $file) || 
             eregi("\.gif$", $file) ||  
             eregi("\.png$", $file)) {
             $files[] = $file; 
         }
      }
      if ($sortreverse) {
          rsort($files);
      } else {
          sort($files);
      }
   }
   return $files; 
} 

function GetNeighbours($imagelist, $currimage, &$previmage, &$nextimage) {
   // For a given image, return the next and previous ones
   $lastimage = count($imagelist) - 1;
   for ( $i=0; $i<=$lastimage; $i++) {
       if ($imagelist[$i] == $currimage) {
           if ($i == 0) { 
               $nextimage = $imagelist[$i+1];
               $previmage = NULL;
               return;
           } else if ($i == $lastimage) {
               $previmage = $imagelist[$i-1];
               $nextimage = NULL;
               return;
           } else {
               $previmage = $imagelist[$i-1];
               $nextimage = $imagelist[$i+1];
               return;
           }
       }
   }
   $previmage = NULL;
   $nextimage = NULL;
   return;

}

function PrintError($message) {
   echo "<P ALIGN=CENTER><FONT COLOR=RED>Error: $message</FONT></P>";
}




function PrintRecentComments($recent) {
   global $thumb, $gallery, $directory;
   global $id,$path;

   if (! $recent) {
      return;
   }

   $imagelist = GetFileList($directory);

   $comments = array();

   foreach ($imagelist as $filename) {
      $commentfile = "$directory/$thumb/$filename.txt";
      if (file_exists($commentfile)) {
         $file = file($commentfile);
         foreach ($file as $line) {
            $line = chop($line)."###$filename";
            $comments[] = $line;
         }
      }
   }
   rsort($comments);
   $count = 0;

   echo "</CENTER></P>";   // Just in case;
   echo "<BR><H3 ALIGN=CENTER>$recent ".get_string("recent",'gallery').":</H3>";
   foreach ($comments as $comment) {
      $comm = explode ("###", $comment);
      $image = $comm[3];
      $caption = GetImageCaption($image, $clean=true);
      $image      = rawurlencode($image);

      echo "<TABLE ALIGN=CENTER WIDTH=\"90%\"><TR><TD COLSPAN=2><HR></TD></TR>";
      echo "<TR>";
      if ($gallery->format == GALLERY_MARGINL || $gallery->format == GALLERY_FORUMMARGINL) {
         echo "<TD VALIGN=TOP WIDTH=\"100%\">";
         echo "<FONT SIZE=2>";
         echo get_string("from",'gallery').": <B>".$comm[1]."</B>, <I>".userdate($comm[0])."</I><BR>";
         echo "<UL>".$comm[2]."</UL></FONT>";
         if (gallery_isowner()) {
            echo "<P ALIGN=right><FONT SIZE=1><A HREF=\"view.php?id=$id&image=$image&dcomment=".$comm[0]."\">".get_string('delete','gallery')."</A></FONT></P>";
         }
         echo "</TD>";
      }

      echo "<TD WIDTH=\"$gallery->thumbsize\">";
      echo "<A TITLE=\"$caption\" HREF=\"view.php?id=$id&image=$image&d=d.html\" TARGET=imain>"; 
      if (file_exists("$directory/$thumb/$image")) {
         echo gallery_display_image("$path/$thumb/$image",$caption,"HSPACE=10");
		 //echo "<IMG HSPACE=10 ALT=\"$caption\" SRC=\"$directory/$thumb/$image\" BORDER=0>";
      } else {
         echo "<FONT SIZE=1>$caption</FONT>";
      }
      echo "</A>";
      echo "</TD>";

      if ($gallery->format == GALLERY_MARGINR || $gallery->format == GALLERY_FORUMMARGINR) {
         echo "<TD VALIGN=TOP WIDTH=\"100%\">";
         echo "<FONT SIZE=2>";
         echo get_string("from",'gallery').": <B>".$comm[1]."</B>, <I>".userdate($comm[0])."</I><BR>";
         echo "<UL>".$comm[2]."</UL></FONT>";
         if (gallery_isowner()) {
            echo "<P ALIGN=right><FONT SIZE=1><A HREF=\"view.php?id=$id&image=$image&dcomment=".$comm[0]."\">".get_string('delete','gallery')."</A></FONT></P>";
         }
         echo "</TD>";
      }

      echo "</TR></TABLE>\n";

      $count++;
      if ($count >= $recent) {
         break;
      }
   }
   echo "<HR>\n";
}

function PrintComments($imagefile) {
   // Given an image imagefile, finds, reads and formats the 
   // associated file of guest comments
   global $thumb, $gallery,$directory, $id;

   $commentfiles["main"] = "$directory/$thumb/$imagefile.txt";
   if ($gallery->comments == GALLERY_MODERATED)  {
       $commentfiles["unmoderated"] = "$directory/$thumb/$imagefile.mod";
   }

   $filename = rawurlencode($imagefile);

   echo "<BLOCKQUOTE><BLOCKQUOTE><HR>\n";

   foreach ($commentfiles as $commenttype => $commentfile) {
      if ($commenttype == "unmoderated" and !gallery_isowner()) {
          continue;
      }
      if (file_exists($commentfile)) {
         $comments = file($commentfile);
         foreach ($comments as $comment) {
   
            $comm = explode ("###", $comment);
   
            echo "<FONT SIZE=2>";
            echo get_string("from",'gallery').": <B>".$comm[1]."</B>, <I>".userdate($comm[0])."</I><BR>";
            echo "<UL>".$comm[2]."</UL></FONT>\n";
            if (gallery_isowner()) {
               echo "<P ALIGN=right><FONT SIZE=1>";
               if ($commenttype == "unmoderated") {
                   echo "<A HREF=\"view.php?id=$id&image=$filename&acomment=".$comm[0]."\">".get_string('approve','gallery')."</A> ";
                   echo "<A HREF=\"view.php?id=$id&image=$filename&dcomment=".$comm[0]."&ctype=mod\">".get_string('delete','gallery')."</A>";
               } else {
                   echo "<A HREF=\"view.php?id=$id&image=$filename&dcomment=".$comm[0]."\">".get_string('delete','gallery')."</A>";
               }
               echo "</FONT></P>";
            }
            echo "<HR SIZE=1>\n";
         }
      }
   }
   echo "</BLOCKQUOTE></BLOCKQUOTE><BR>\n";

}

function DeleteComment($filename, $dcomment, $ctype="") {
   // Given an image filename and a comment ID (time) to 
   // delete, it reads the file and rewrites it, leaving
   // out the specified line.   Returns the deleted line.

   global $thumb,  $directory;

   if ($qs == "mod") {
      $commentfile = "$directory/$thumb/$filename.mod";
   } else {
      $commentfile = "$directory/$thumb/$filename.txt";
   }

   $len = strlen($dcomment);

   if (file_exists($commentfile)) {
      $comments = file($commentfile);
      rename($commentfile, $commentfile.".bak");
      if ($file = fopen ($commentfile, "a")) {
         foreach ($comments as $comment) {
            if (substr($comment, 0, $len) == $dcomment) {
               $deletedcomment = $comment;
            } else {
               fwrite($file, "$comment");
            }
         }
         unlink($commentfile.".bak");
      } else {   // some error occurred ... try to undo the mess
         PrintError("Could not delete comment from file!");
         rename($commentfile.".bak", $commentfile);
      }
   } else {
      PrintError("No comments exist for this image! ($filename)");
   }

   return $deletedcomment;

}


function ApproveComment($filename, $commentid) {
   // Given an image filename and a comment ID (time) to 
   // approve, it moves the comment from the .mod file 
   // to the .txt file

   if ($commentline = DeleteComment($filename, $commentid, "mod")) {
      AddComment($filename, "", "", $commentline);
      echo "<P ALIGN=CENTER>".getstring('messageapproved','gallery')."</P>";
   }
}


function PrintCommentForm($filename) {
      global  $id;
	

?>

<FORM ACTION=view.php METHOD=POST>
<INPUT TYPE=hidden NAME=comment VALUE="<?PHP echo $filename?>">
<TABLE BORDER=0 CELLPADDING=2 CELLSPACING=0 ALIGN=CENTER>
<TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH="100%">
   
   <TR>
       <TD ALIGN=right valign=top><FONT SIZE=2>
           <B><?PHP echo get_string("message",'gallery') ?>:</B></FONT></TD>
       <TD><FONT SIZE=2>
           <TEXTAREA name="message" rows=4 cols=40></TEXTAREA></FONT></TD>
   </TR>
   <TR>
       <TD ALIGN=CENTER COLSPAN=2>
          <FONT SIZE=2>
		  <INPUT type=hidden NAME=id VALUE="<?PHP echo $id?>">	  
		  <INPUT type=submit value="<?PHP echo get_string("add",'gallery') ?>"></FONT>
		  
       </TD>
   </TR>
</TABLE></TD></TR></TABLE>
</FORM>

<?PHP
}


function gallery_add_comment($filename, $message, $messageline="") {
   // Clean up a given comment and add to the appropriate database
   global $thumb, $directory, $title, $gallery, $USER;
   
   if (ereg( "\\.\\.", $filename)) {  // using ".." in the filename
       PrintError("That filename ($filename) was not secure.");
       return;
   }
            
    if (!$message and !$messageline) {
       PrintError("There was no message to post.");
       return;
   }

   if ($gallery->comments == GALLERY_MODERATED and !$messageline) {
       $commentfile = "$directory/$thumb/$filename.mod";
   } else {
       $commentfile = "$directory/$thumb/$filename.txt";
   }

   if ($file = fopen ($commentfile, "a") ) {
       if ($messageline) {
          fwrite($file, "$messageline");
           
       } else {
          $timenow = time();
          $name    = strip_tags(fullname($USER));
          $message = stripslashes(strip_tags($message, "<a><b>"));
          $message = nl2br($message);
          $message = strtr($message, "\r", " ");
          $message = strtr($message, "\n", " ");
          fwrite($file, "$timenow###$name###$message\n");
       }
       fclose($file);

   } else {
       PrintError("Could not add comment for $filename");
   }
}


function CleanCaption ($caption) {
   $caption = strtr($caption, "\r", " ");
   $caption = strtr($caption, "\n", " ");
   $caption = htmlentities(strip_tags($caption));
   return $caption;
}


function GetImageCaption($image, $clean=false) {
   global $thumb,$directory, $captionmethod, $rdjpgcom, $identify;

   $caption = "";

   switch ($captionmethod) {
      case "imagemagick": 
         if (file_exists($image)) {
            Exec("$identify -ping -format \"%c\" \"$image\"", $captionlines);
         } else {
	        return "";
         }
      break;
      case "rdjpgcom": 
         if (file_exists($image)) {
            Exec("$rdjpgcom \"$image\"", $captionlines);
         } else {
	        return "";
         }
      break;
      case "capfile":
         $capfile = $directory."/".$thumb."/".$image.".cap";
         if (file_exists($capfile)) {
            $captionlines = file($capfile);
         } else {
	        return "";
         }
      break;
      case "filename":
          return $image;
      break;
      default:
         return "";
      break;
   }

   foreach ($captionlines as $captionline) {
      $caption .= "$captionline ";
   }

   $caption = stripslashes($caption);

   if ($clean) {
      $caption = CleanCaption($caption);
   }

   return $caption;
}

function SetImageCaption($image, $caption) {
   global $thumb, $captionmethod, $wrjpgcom, $directory;

   $TEMPFILE = $directory."/".$thumb."/ttttmpfile.jpg";

   if (file_exists($TEMPFILE)) {
      unlink($TEMPFILE);
   }

   $caption = stripslashes($caption);

   switch ($captionmethod) {
      case "rdjpgcom": 
         if (!eregi("\.jpe?g$", $image)) {
            PrintError("$image is probably not a JPEG file");
            return false;
         }
         $command = "$wrjpgcom -replace -comment ".EscapeShellArg($caption)." ".EscapeShellArg($image);
         Exec("$command > $TEMPFILE");
         if (file_exists($TEMPFILE) and filesize($TEMPFILE) > 0) {
            return rename($TEMPFILE, $$image);
         }
      break;
      case "capfile":
         $capfile = $directory."/".$thumb."/".$image.".cap";
         if (! $file = fopen ($capfile, "w")) {
            PrintError("Could not open the caption file $capfile");
            return false;
         }
         if (! fwrite($file, $caption)) {
            PrintError("Could not write the caption to the caption file $capfile");
            return false;
         }
	     return true;
      break;
   }

   return false;
}

function ReadImageFromFile($filename, $type) {
   $imagetypes = ImageTypes();
   global $directory;
   $filename = "$directory/$filename";
   
   switch ($type) {
      case 1 :
         if ($imagetypes & IMG_GIF)
             return $im = ImageCreateFromGIF($filename);
         break;
      case 2 :
         if ($imagetypes & IMG_JPEG)
             return ImageCreateFromJPEG($filename);
         break;
      case 3 :
         if ($imagetypes & IMG_PNG)
             return ImageCreateFromPNG($filename);
         break;
      default:
         return 0;
   }
}

function WriteImageToFile($im, $filename, $type) {
   global $imagequality, $directory;

   $filename = "$directory/$filename";
   switch ($type) {
      case 1 :
         return ImageGIF($im, $filename);
      case 2 :
         return ImageJpeg($im, $filename, $imagequality);
      case 3 :
         return ImagePNG($im, $filename);
      default:
         return false;
   }
}


function ResizeImage($image, $newimage, $newwidth, $newheight=0) {
// Returns true if new image was created, else false
// If newheight is not specified then image is scaled in proportion
// to newwidth.  If newheight is specified, then newheight and newwidth
// represent a bounding box to fit image into
   global $imagemethod;
 
   switch ($imagemethod) {
      case "imagemagick":
         return ResizeImageUsingIM($image, $newimage, $newwidth, $newheight);
      break;
      case "gd1":
      case "gd2":
         return ResizeImageUsingGD($image, $newimage, $newwidth, $newheight);
      break;
      case "manual":
         return true;
      break;
      default:
         return false;
      break;
   }
}

function ResizeImageUsingGD($image, $newimage, $newwidth, $newheight) {
   global $imagemethod, $directory;  //need the directory to pass complete filename to GetImageSize

   $size = GetImageSize("$directory/$image");
   $width  = $size[0];
   $height = $size[1];
   $type   = $size[2];

   if ($im = ReadImageFromFile($image, $type)) {
      if ($newheight && ($width < $height)) {
         $newwidth = ($newheight / $height) * $width;
      } else {
         $newheight = ($newwidth / $width) * $height;
      }
      if ($imagemethod == "gd2") {
         $im2 = ImageCreateTrueColor($newwidth,$newheight);
      } else {
         $im2 = ImageCreate($newwidth,$newheight);
      }
      if ($imagemethod == "gd2") {
          ImageCopyResampled($im2,$im,0,0,0,0,$newwidth,$newheight,$width,$height);
      } else {
          ImageCopyResized($im2,$im,0,0,0,0,$newwidth,$newheight,$width,$height);
      }

      if (WriteImageToFile($im2, $newimage, $type)) {
          return true;
      }
   }
   return false;
}

function ResizeImageUsingIM($image, $newimage, $newwidth, $newheight) {
   global $identify, $convert, $imagequality; // needs updating to include $directory

   Exec("$identify -ping -format \"%w %h\" \"$image\"", $sizeinfo);

   if (! $sizeinfo ) {
      return false;
   }
   $size = explode(" ", $sizeinfo[0]);
   $width  = $size[0];
   $height = $size[1];

   if (!$width) {
      return false;
   }

   if ($newheight && ($width < $height)) {
      $newwidth = ($newheight / $height) * $width;
   } else {
      $newheight = ($newwidth / $width) * $height;
   }

   Exec("$convert -geometry \"$newwidth"."x"."$newheight\" -quality \"$imagequality\" \"$image\" \"$newimage\"");

   return file_exists($newimage);
}


function PrintSlideshowForm ($nextimage,$slide=0) {
   global $id; //coursemoduleid
   $common = "view.php?image=$nextimage&id=$id&slide=";
   $options = array (2 => "2 ".get_string("seconds",'gallery'), 
                     5 => "5 ".get_string("seconds",'gallery'), 
                     7 => "7 ".get_string("seconds",'gallery'), 
                     10 => "10 ".get_string("seconds",'gallery'), 
                     20 => "20 ".get_string("seconds",'gallery'), 
                     30 => "30 ".get_string("seconds",'gallery'),
                     40 => "40 ".get_string("seconds",'gallery'), 
                     50 => "50 ".get_string("seconds",'gallery'), 
                     60 => "60 ".get_string("seconds",'gallery'));

   echo "<FORM NAME=auto>";
   echo "<SELECT NAME=popup onChange=\"window.location=document.auto.popup.options[document.auto.popup.selectedIndex].value\">\n";

   echo "   <OPTION VALUE=\"javascript:void(0)\">".get_string("slide",'gallery')."...</OPTION>\n";
   foreach ($options as $value => $label) {
      echo "   <OPTION VALUE=\"$common$value\"";
      if ($value == $slide) {
         echo " SELECTED";
      }
      if ($label) {
         echo ">$label</OPTION>\n";
      } else {
         echo ">$value</OPTION>\n";
      }
   }
   echo "</SELECT></FORM>";
}

?>